module dmd.HaltExp;

import dmd.Expression;
import dmd.backend.elem;
import dmd.OutBuffer;
import dmd.Loc;
import dmd.Scope;
import dmd.IRState;
import dmd.Type;
import dmd.HdrGenState;
import dmd.Loc;
import dmd.TOK;

import dmd.backend.Util;
import dmd.backend.OPER;
import dmd.backend.TYM;

class HaltExp : Expression
{
	this(Loc loc)
	{
		super(loc, TOK.TOKhalt, HaltExp.sizeof);
	}

	Expression semantic(Scope sc)
	{
version (LOGSEMANTIC) {
		printf("HaltExp.semantic()\n");
}
		type = Type.tvoid;
		return this;
	}

	void toCBuffer(OutBuffer buf, HdrGenState* hgs)
	{
		buf.writestring("halt");
	}

	bool checkSideEffect(int flag)
	{
		return true;
	}

	elem* toElem(IRState* irs)
	{
		elem *e;

		e = el_calloc();
		e.Ety = TYvoid;
		e.Eoper = OPhalt;
		el_setLoc(e,loc);
		return e;
	}
}

